package bookExamples.ch44Printing;

import gui.ClosableJFrame;

import javax.print.PrintService;
import javax.swing.*;
import java.awt.*;
import java.awt.print.PageFormat;
import java.awt.print.Printable;
import java.awt.print.PrinterException;
import java.awt.print.PrinterJob;
//todo make this into a general printer of arrays of components.

public class ComponentPrintTest implements Printable {
    private Container containerArray[];

    public ComponentPrintTest(Container c[]) {
        this.containerArray = c;
        System.out.println("JPanelArray has" + c.length + " elements");
    }

    public static JPanel getWhitePanel(final int w, final int h) {
        JPanel jp = new JPanel() {
            public Dimension getPreferredSize() {
                return new Dimension(w, h);
            }
        };
        jp.setBackground(Color.WHITE);
        return jp;
    }

    public int print(Graphics graphics, PageFormat pf, int pageIndex)
            throws PrinterException {
        if (pageIndex < containerArray.length) {
            Graphics2D g2d = (Graphics2D) graphics;
            System.out.println("printing page number:" + pageIndex);
            double imageableWidth = pf.getImageableWidth();
            double imageableHeight = pf.getImageableHeight();
            g2d.translate((int) pf.getImageableX(), (int) pf.getImageableY());
            System.out.println("pf.getOrientation()=" + pf.getOrientation());
            if (pf.getOrientation() == PageFormat.LANDSCAPE) {
                g2d.rotate(90 * Math.PI / 180, pf.getWidth() / 2, pf.getHeight() / 2);
            }
            Container container = containerArray[pageIndex];
            container.setSize((int) imageableWidth, (int) imageableHeight);
            container.setVisible(true);
            System.out.println("wxh=" + imageableWidth + " " + imageableHeight);
            System.out.println("location:" + (int) pf.getImageableX() + " " + (int) pf.getImageableY());
            ClosableJFrame cf = new ClosableJFrame();
            cf.getContentPane().add(container);
            cf.setSize(container.getSize());
            cf.setVisible(true);
            container.printAll(graphics);

            return PAGE_EXISTS;
        } else
            return NO_SUCH_PAGE;
    }

    public static void main(String[] args) {
        print();
    }

    public static void print() {
        PrinterJob printerJob = PrinterJob.getPrinterJob();
        PrintService[] printService = PrinterJob.lookupPrintServices();
        for (int i = 0; i < printService.length; i++) {
            System.out.println(printService[i].getName());
        }
        PageFormat pageFormat = printerJob.defaultPage();
        JPanel jPanelArray[] = new JPanel[1];

        for (int i = 0; i < jPanelArray.length; i++) {
            jPanelArray[i] = new JPanel();
            jPanelArray[i].setLayout(new GridLayout(2, 2));
            jPanelArray[i].add(new JButton("i=" + i));
            jPanelArray[i].add(new JButton("i=" + i));
            jPanelArray[i].add(new JButton("i=" + i));
            jPanelArray[i].add(new JButton("i=" + i));

        }

        if (printerJob.printDialog()) {
            printerJob.setPrintable(new ComponentPrintTest(jPanelArray), pageFormat);
            // The 2nd param is necessary for printing into
            // a label width a right landscape format.
            try {
                printerJob.print();
            } catch (PrinterException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            }
        }
    }
}

 
